proc new_bp {name lat long} {
   global bplist
   set name [string tolower $name]
   lappend bplist() $name
   set bplist($name) [list $lat $long]
}

proc get_ww_quad {line} {
   global bplist
\
   set retlist [list]
   foreach s $bplist() {
      if {[string first $s $line] >= 0} {
         lappend retlist [lindex $bplist($s) 1]
         lappend retlist [lindex $bplist($s) 0]
      }
   }
   if {[llength $retlist] == 4} { return $retlist }
   return [list]
}

set bplist() [list]

new_bp "AL/FL border"                              30.27   87.55
new_bp "Acapulco"                                  16.85   99.92
new_bp "Agua Blanca"                               23.62   110.38
new_bp "Albemarle Sound"                           36.05   76.00
new_bp "Altamaha Sound"                            31.29   81.29
new_bp "Altata"                                    24.63   107.92
new_bp "Anclote Key"                               28.18   82.85
new_bp "Anna Maria Island"                         27.53   82.73
new_bp "Anse d'Hainault (SW tip Haiti)"            18.49   74.45
new_bp "Anticosti Island"                          49.49   63.08
new_bp "Antigua/Barbuda"                           17.35   61.80
new_bp "Apalachicola"                              29.73   84.99
new_bp "Aripeka"                                   28.43   82.66
new_bp "Arnold's Cove"                             47.82   54.07
new_bp "Aruba, Bonaire, Curacao"                   12.35   69.00
new_bp "Aucilla River"                             30.04   83.92
new_bp "Aulds Cove"                                45.63   61.43
new_bp "Avonport"                                  45.12   64.22
new_bp "Baffin Bay"                                27.29   97.37
new_bp "Bahamas (Andros only)"                     24.40   77.90
new_bp "Bahamas (Central)"                         24.00   75.50
new_bp "Bahamas (NW not Andros)"                   25.90   77.40
new_bp "Bahamas (Southeast)"                       22.00   73.50
new_bp "Bahia Algodones"                           24.47   97.65
new_bp "Bahia De Los Angeles"                      28.91   113.54
new_bp "Bahia Kino"                                28.77   111.94
new_bp "Bahia Magdalena"                           24.76   112.06
new_bp "Bahia San Juan Bautista"                   28.03   112.80
new_bp "Bar Harbor"                                44.39   68.20
new_bp "Barahona"                                  18.20   71.08
new_bp "Barbados"                                  13.15   59.55
new_bp "Barra De Nautla"                           20.25   96.78
new_bp "Barra De Tonala"                           16.00   93.97
new_bp "Barranquilla"                              11.10   74.83
new_bp "Batteau"                                   53.47   56.08
new_bp "Beaupre"                                   47.07   70.80
new_bp "Belize City"                               17.48   88.18
new_bp "Belledune"                                 47.90   65.87
new_bp "Bermuda"                                   32.30   64.75
new_bp "Betsiamites"                               49.02   68.83
new_bp "Block Island"                              41.16   71.56
new_bp "Bluefields"                                12.00   83.75
new_bp "Boat Harbour"                              51.58   55.95
new_bp "Boca De Pijijiapan"                        15.57   93.31
new_bp "Boca Grande"                               26.75   82.26
new_bp "Boca Raton"                                26.36   80.07
new_bp "Bogue Inlet"                               34.64   77.11
new_bp "Bonita Beach"                              26.32   81.84
new_bp "Border of Colombia/Venezuela"              11.85   71.32
new_bp "Border of Costa Rica/Panama"                9.56   82.56
new_bp "Border of Honduras/Nicaragua"              15.00   83.13
new_bp "Border of Nicaragua/Costa Rica"            10.93   83.69
new_bp "Border of Panama/Colombia"                  8.67   77.37
new_bp "Border of Venezuela/Guyana"                 8.53   59.98
new_bp "Brigus South"                              47.17   52.87
new_bp "Brule "                                    45.73   63.13
new_bp "Buenavista"                                23.67   109.69
new_bp "Burgeo"                                    47.63   57.45
new_bp "Cabo Beata"                                17.58   71.46
new_bp "Cabo Catoche"                              21.62   87.12
new_bp "Cabo Colnett"                              30.96   116.28
new_bp "Cabo Corrientes"                           20.42   105.68
new_bp "Cabo Engano"                               18.59   68.31
new_bp "Cabo Frances Viejo"                        19.62   69.90
new_bp "Cabo Rojo"                                 21.56   97.32
new_bp "Cabo San Antonio"                          21.83   84.93
new_bp "Cabo San Lucas"                            22.87   109.92
new_bp "Calamajue"                                 29.76   114.28
new_bp "Camaguey/Ciego de Avila"                   21.51   78.63
new_bp "Camaguey/Las Tunas"                        21.48   76.97
new_bp "Cameron"                                   29.78   93.30
new_bp "Campeche"                                  19.85   90.52
new_bp "Cancun"                                    21.18   86.82
new_bp "Cap Chat"                                  49.12   66.65
new_bp "Cape Charles Light"                        37.12   75.90
new_bp "Cape Elizabeth"                            43.56   70.19
new_bp "Cape Fear"                                 33.84   77.96
new_bp "Cape Hatteras"                             35.22   75.53
new_bp "Cape Henlopen"                             38.80   75.09
new_bp "Cape Lookout"                              34.60   76.53
new_bp "Cape May"                                  38.94   74.90
new_bp "Cape St. Gregory"                          49.38   58.23
new_bp "Caracas"                                   10.60   66.93
new_bp "Card Sound Bridge"                         25.29   80.37
new_bp "Celestun"                                  20.82   90.42
new_bp "Charlottetown"                             48.37   53.90
new_bp "Chassahowitzka"                            28.70   82.66
new_bp "Chatham"                                   41.67   69.95
new_bp "Chesapeake Bay Drum Point"                 38.32   76.42
new_bp "Chesapeake Bay New Point Comfort"          37.30   76.28
new_bp "Chesapeake Bay North Beach"                38.70   76.53
new_bp "Chesapeake Bay Pooles Island"              39.29   76.27
new_bp "Chesapeake Bay Sandy Point"                39.02   76.40
new_bp "Chesapeake Bay Smith Point"                37.89   76.24
new_bp "Chesapeake Bay Windmill Point"             37.61   76.28
new_bp "Chetumal"                                  18.48   88.30
new_bp "Chilitepec"                                18.44   93.09
new_bp "Chincoteague"                              37.93   75.32
new_bp "Chokoloskee"                               25.78   81.38
new_bp "Ciego de Avila/Camaguey"                   22.08   78.08
new_bp "Ciego de Avila/Sancti Spiritus"            21.59   79.00
new_bp "Cienfuegos/Matanzas"                       22.05   80.62
new_bp "Ciudad Del Carmen"                         18.63   91.83
new_bp "Ciudad de la Habana/La Habana"             23.17   82.22
new_bp "Cloridome"                                 49.12   64.75
new_bp "Coatzacoalcos"                             18.15   94.45
new_bp "Cocoa Beach"                               28.32   80.61
new_bp "Colon"                                      9.38   79.86
new_bp "Costa Rica/Panama border"                   8.03   82.90
new_bp "Craig Key"                                 24.83   80.77
new_bp "Cumana"                                    10.47   64.20
new_bp "Deerfield Beach"                           26.32   80.07
new_bp "Destin"                                    30.39   86.50
new_bp "Digby"                                     44.67   65.76
new_bp "Dominica"                                  15.40   61.35
new_bp "Dry Tortugas Island"                       24.66   82.86
new_bp "Duck"                                      36.23   75.77
new_bp "East Albemarle Sound"                      36.05   76.35
new_bp "East Cape Sable"                           25.12   81.08
new_bp "Eastport"                                  44.92   67.00
new_bp "Ecum Secum"                                44.97   62.17
new_bp "Edisto Beach"                              32.49   80.32
new_bp "El Pocito"                                 27.15   114.28
new_bp "El Roblito"                                22.40   105.66
new_bp "El Salvador/Honduras border"               13.40   87.81
new_bp "Englewood"                                 26.94   82.37
new_bp "Fernandina Beach"                          30.66   81.44
new_bp "Fire Island Inlet"                         40.63   73.31
new_bp "Five Islands"                              45.40   64.09
new_bp "Flagler Beach"                             29.47   81.12
new_bp "Flamingo"                                  25.14   80.93
new_bp "Florida Bay"                               24.95   80.90
new_bp "Fogo Island"                               49.63   54.20
new_bp "Fort Lawrence"                             45.82   64.27
new_bp "Fort Pierce"                               27.45   80.28
new_bp "Fourchu"                                   45.72   60.27
new_bp "Fox Island River"                          48.77   58.63
new_bp "Freeport"                                  28.93   95.33
new_bp "French Frigate Shoals"                     23.86   166.27
new_bp "Fundy National Park"                       45.57   65.01
new_bp "Georgetown"                                 6.82   58.17
new_bp "Gloucester"                                42.58   70.66
new_bp "Golden Beach"                              25.97   80.12
new_bp "Gonaives"                                  19.48   72.70
new_bp "Grand Cayman"                              19.32   81.26
new_bp "Grand Isle"                                29.25   89.96
new_bp "Grand Manan"                               44.72   66.81
new_bp "Grand-Anse"                                47.80   65.23
new_bp "Grand-Riviere "                            48.40   64.47
new_bp "Granma/Las Tunas"                          20.71   77.33
new_bp "Great Egg Inlet"                           39.29   74.54
new_bp "Grenada"                                   12.10   61.70
new_bp "Grenadines/St. Vincent"                    13.20   61.20
new_bp "Guadeloupe"                                16.20   61.50
new_bp "Guantanamo/Santiago de Cuba"               19.90   75.46
new_bp "Guatemala/El Salvador border"              13.74   90.12
new_bp "Guaymas"                                   27.90   110.88
new_bp "Hallandale Beach"                          25.99   80.12
new_bp "Harbour Deep"                              50.23   56.53
new_bp "Hare Bay"                                  48.90   53.98
new_bp "Hawke's Bay"                               50.58   57.38
new_bp "High Island"                               29.54   94.39
new_bp "Holguin/Guantanamo"                        20.49   74.62
new_bp "Honduras/Nicaragua border"                 12.98   87.30
new_bp "Hopedale"                                  55.28   60.43
new_bp "Huatabampito"                              26.67   109.67
new_bp "Hubbards"                                  44.62   64.07
new_bp "Hull"                                      42.30   70.91
new_bp "Indian Pass"                               29.68   85.27
new_bp "Intracoastal City"                         29.62   92.04
new_bp "Isla Saona"                                18.15   68.68
new_bp "Isle of Youth (Cuba)"                      21.70   82.85
new_bp "Jamaica (all)"                             18.10   77.30
new_bp "Jamaica (north coast)"                     18.50   77.50
new_bp "Jamaica (south coast)"                     17.70   77.20
new_bp "Johan Beetz Bay"                           50.30   63.00
new_bp "Jones Harbour"                             47.92   53.70
new_bp "Jupiter Inlet"                             26.95   80.07
new_bp "Keaton Beach"                              29.82   83.59
new_bp "Key West"                                  24.55   81.81
new_bp "Kure Atoll"                                28.42   178.33
new_bp "L'Anse-au-Clair"                           51.45   57.18
new_bp "La Cruz W"                                 23.86   106.91
new_bp "La Cruz"                                   22.99   97.74
new_bp "La Fortuna"                                19.57   105.10
new_bp "La Habana/Ciudad de la Habana"             23.02   82.75
new_bp "La Habana/Matanzas"                        23.15   81.76
new_bp "La Habana/Pinar del Rio"                   22.69   82.85
new_bp "La Paz"                                    24.17   110.30
new_bp "La Pesca"                                  23.76   97.75
new_bp "La Pocatiere"                              47.35   70.03
new_bp "Lagunas De Chacahua"                       15.96   97.71
new_bp "Lake Maurepas"                             30.25   90.54
new_bp "Lake Okeechobee"                           26.95   80.80
new_bp "Las Tunas/Camaguey"                        20.71   77.83
new_bp "Las Tunas/Holguin"                         21.25   76.34
new_bp "Lazaro Cardenas"                           17.93   102.18
new_bp "Le Mole St Nicholas (NW tip Hti)"          19.70   73.43
new_bp "Les Bergeronnes"                           48.25   69.50
new_bp "Limon"                                     15.86   85.52
new_bp "Lisianksi"                                 26.08   174.00
new_bp "Lismore"                                   45.70   62.23
new_bp "Little Cayman, Cayman Brac"                19.70   79.94
new_bp "Little Egg Inlet"                          39.49   74.31
new_bp "Little River Inlet"                        33.85   78.55
new_bp "Loreto"                                    26.02   111.35
new_bp "Lower East Pubnico"                        43.60   65.77
new_bp "MS/AL border"                              30.40   88.40
new_bp "Mabou"                                     46.10   61.48
new_bp "Magdalen Islands"                          47.46   61.78
new_bp "Malagash"                                  45.75   63.38
new_bp "Manasquan Inlet"                           40.10   74.03
new_bp "Manzanillo"                                19.05   104.33
new_bp "Margaretsville"                            45.07   65.03
new_bp "Maro Reef"                                 25.33   170.50
new_bp "Martha's Vineyard"                         41.38   70.63
new_bp "Martinique"                                14.70   61.00
new_bp "Matagorda"                                 28.63   95.93
new_bp "Matane"                                    48.80   67.60
new_bp "Matanzas/La Habana"                        22.55   81.63
new_bp "Matanzas/Villa Clara"                      23.11   80.62
new_bp "Mazatlan"                                  23.20   106.42
new_bp "Meat Cove"                                 47.00   60.53
new_bp "Medway Harbour"                            44.13   64.55
new_bp "Merrimack River"                           42.81   70.82
new_bp "Mexico Beach"                              29.93   85.39
new_bp "Mexico/Guatemala border"                   14.54   92.24
new_bp "Mexico/United States border"               32.52   117.13
new_bp "Middle of Longboat Key"                    27.39   82.64
new_bp "Midway"                                    28.02   177.37
new_bp "Montauk Point"                             41.07   71.86
new_bp "Morgan City"                               29.48   91.29
new_bp "Moriches Inlet"                            40.77   72.75
new_bp "Mouth Mississippi River"                   29.12   89.10
new_bp "Mouth Pearl River"                         30.15   89.60
new_bp "Mouth of San Gabriel River"                33.75   118.11
new_bp "Mouth of Tijuana River"                    32.53   117.12
new_bp "Mouth of the Rio Grande"                   25.96   97.15
new_bp "Mulege"                                    26.90   111.97
new_bp "Murrells Inlet"                            33.56   79.01
new_bp "Musquaro"                                  50.22   61.00
new_bp "Mutton Bay"                                50.87   59.00
new_bp "N Entrance Padre Island Natl Seashore"     27.47   97.29
new_bp "NC/VA border"                              36.55   75.87
new_bp "Nain"                                      56.58   62.00
new_bp "Nantucket"                                 41.27   70.04
new_bp "New Bonaventure"                           48.25   53.50
new_bp "New Carlisle"                              48.02   65.33
new_bp "New Haven"                                 41.30   72.91
new_bp "New River Inlet"                           34.53   77.34
new_bp "New Smyrna Beach"                          29.03   80.89
new_bp "Nicaragua/Costa Rica border"               11.07   85.69
new_bp "Nihoa"                                     23.05   161.92
new_bp "North Pamlico Sound"                       35.26   76.04
new_bp "North Slaughter Beach to East Point"       39.10   75.25
new_bp "Northern border Dominican Republic/Haiti"  19.70   71.74
new_bp "Ocean Reef Coastal"                        25.36   80.31
new_bp "Ocean Reef"                                25.33   80.26
new_bp "Ochlockonee River"                         29.96   84.38
new_bp "Ocracoke Inlet"                            35.06   76.00
new_bp "Onslow"                                    45.36   63.39
new_bp "Oregon Inlet"                              35.77   75.53
new_bp "P. Barrios"                                15.87   88.83
new_bp "P. Cabezas"                                14.02   83.38
new_bp "Palma Sola"                                19.77   96.42
new_bp "Pamlico Sound"                             35.35   75.85
new_bp "Panama City"                               30.12   85.70
new_bp "Panama/Colombia border"                     7.23   77.88
new_bp "Parramore Island"                          37.52   75.64
new_bp "Parson's Pond"                             49.98   57.73
new_bp "Pascagoula"                                30.35   88.55
new_bp "Pearl and Hermes Atoll"                    27.83   175.83
new_bp "Pedernales"                                 9.97   62.25
new_bp "Pen de Paraguana"                          12.12   70.20
new_bp "Pinar del Rio/La Habana"                   23.02   82.95
new_bp "Plymouth"                                  41.98   70.65
new_bp "Point Aconi"                               46.32   60.32
new_bp "Point Conception"                          34.45   120.45
new_bp "Point Escuminac"                           47.06   64.84
new_bp "Point Judith"                              41.37   71.50
new_bp "Point Lepreau"                             45.09   66.45
new_bp "Point Mugu"                                34.11   119.12
new_bp "Point Tupper"                              45.58   61.35
new_bp "Port Aransas"                              27.83   97.07
new_bp "Port Bolivar"                              29.38   94.76
new_bp "Port Cartier"                              49.32   67.38
new_bp "Port Clyde"                                43.92   69.25
new_bp "Port Jefferson Harbor"                     40.96   73.08
new_bp "Port Maitland"                             43.97   66.15
new_bp "Port Mansfield"                            26.60   97.29
new_bp "Port O'Connor"                             28.39   96.41
new_bp "Port OConnor"                              28.39   96.41
new_bp "Port aux Basques"                          47.70   59.30
new_bp "Port l'Hebert"                             43.83   64.90
new_bp "Port-Au-Prince"                            18.55   72.33
new_bp "Porter's Lake "                            44.68   63.22
new_bp "Portsmouth"                                43.05   70.72
new_bp "Prince Edward Island"                      46.34   63.35
new_bp "Progresso"                                 21.28   89.66
new_bp "Provincetown"                              42.06   70.25
new_bp "Puerto Angel"                              15.66   96.48
new_bp "Puerto Libertad"                           29.92   112.72
new_bp "Puerto Penasco"                            31.30   113.53
new_bp "Puerto Plata"                              19.80   70.68
new_bp "Puerto Rico East Central"                  18.30   65.62
new_bp "Puerto Rico North Central"                 18.47   66.31
new_bp "Puerto Rico Northeast"                     18.41   65.78
new_bp "Puerto Rico Northwest"                     18.47   67.16
new_bp "Puerto Rico South Central"                 17.97   66.33
new_bp "Puerto Rico Southeast"                     17.97   65.91
new_bp "Puerto Rico Southwest"                     17.95   67.21
new_bp "Puerto Rico West Central"                  18.16   67.17
new_bp "Puerto San Andresito"                      25.80   112.13
new_bp "Punta Abreojos"                            26.70   113.56
new_bp "Punta Allen"                               19.78   87.47
new_bp "Punta Baja"                                29.95   115.75
new_bp "Punta El Lagarto"                          18.55   95.02
new_bp "Punta Eugenia"                             27.86   115.05
new_bp "Punta Gruesa"                              19.00   87.60
new_bp "Punta Maisi"                               20.24   74.14
new_bp "Punta Maldonado"                           16.33   98.55
new_bp "Punta Mariato"                              7.20   80.87
new_bp "Punta San Telmo"                           18.32   103.45
new_bp "Punta Xochen"                              19.08   91.07
new_bp "Rio San Fernando"                          25.00   97.53
new_bp "Saba/Nevis/St.Kitt/St.E/Montserrat"        17.30   62.70
new_bp "Sabine Pass"                               29.69   93.84
new_bp "Sagamore Beach"                            41.80   70.53
new_bp "Saint-Simeon"                              47.85   69.88
new_bp "Saint-Simon"                               48.28   68.97
new_bp "Saint-Vallier"                             46.93   70.63
new_bp "Salina Cruz"                               16.16   95.18
new_bp "Samana"                                    19.20   69.33
new_bp "San Andres"                                12.55   81.70
new_bp "San Blas"                                  21.52   105.27
new_bp "San Evaristo"                              24.92   110.70
new_bp "San Felipe W"                              31.00   114.83
new_bp "San Felipe"                                21.57   88.25
new_bp "San Jose De Las Palomas"                   28.93   114.50
new_bp "San Luis Pass"                             29.07   95.13
new_bp "San Mateo Point"                           33.38   117.60
new_bp "Sancti Spiritus/Ciego de Avila"            22.40   78.93
new_bp "Sancti Spiritus/Cienfuegos"                21.83   80.13
new_bp "Sandy Hook"                                40.46   74.00
new_bp "Santa Fe"                                  24.18   111.14
new_bp "Santiago de Cuba/Granma"                   19.89   77.07
new_bp "Santo Domingo"                             18.46   69.88
new_bp "Sargent"                                   28.77   95.60
new_bp "Savannah River"                            32.03   80.86
new_bp "Sebastian Inlet"                           27.83   80.43
new_bp "Seven Mile Bridge"                         24.70   81.15
new_bp "Shediac"                                   46.26   64.53
new_bp "Sheldrake"                                 50.27   65.00
new_bp "Shelia"                                    47.32   64.97
new_bp "Sipacate"                                  13.90   91.19
new_bp "South Pamlico Sound"                       35.24   76.04
new_bp "South Santee River"                        33.12   79.27
new_bp "South Slaughter Beach to East Point"       38.91   75.30
new_bp "Southern border Dominican Republic/Haiti"  18.02   71.75
new_bp "St Augustine"                              29.88   81.27
new_bp "St Marks"                                  30.10   84.20
new_bp "St. Lucia"                                 13.90   60.95
new_bp "St. Mart/St. Bart/Anguilla"                18.00   63.00
new_bp "Steinhatchee River"                        29.67   83.40
new_bp "Stone's Cove"                              47.60   55.13
new_bp "Stonington ME"                             44.16   68.64
new_bp "Stuart"                                    27.21   80.18
new_bp "Surf City NC"                              34.44   77.52
new_bp "Suwannee River"                            29.30   83.17
new_bp "Tampico"                                   22.21   97.79
new_bp "Tarpon Springs"                            28.15   82.79
new_bp "Tecpan De Galeana"                         17.15   100.68
new_bp "Tidal Potomac Cobb Island"                 38.26   76.84
new_bp "Tidal Potomac Indian Head"                 38.61   77.15
new_bp "Tidal Potomac Key Bridge"                  38.89   77.07
new_bp "Tidnish"                                   46.00   64.03
new_bp "Tobago"                                    11.25   60.65
new_bp "Topolobampo"                               25.58   109.07
new_bp "Trinidad"                                  10.50   61.25
new_bp "Triton"                                    49.42   55.65
new_bp "Tulum"                                     20.22   87.43
new_bp "Turks and Caicos"                          21.75   71.60
new_bp "Tuxpan"                                    20.95   97.29
new_bp "Venezuela (Isla de Margarita)"             11.00   64.00
new_bp "Veracruz"                                  19.20   96.11
new_bp "Vero Beach"                                27.65   80.35
new_bp "Villa Clara/Sancti Spiritus"               22.45   79.40
new_bp "Virgin Is. (British)"                      18.55   64.45
new_bp "Virgin Is. (U.S.)"                         18.05   64.80
new_bp "Volusia/Brevard County Line"               28.79   80.73
new_bp "Walton/Bay County Line"                    30.28   85.98
new_bp "Watch Hill"                                41.31   71.86
new_bp "Westport"                                  41.50   71.11
new_bp "Woods Hole"                                41.52   70.68
new_bp "Yankeetown"                                29.03   82.75
new_bp "Zihuatanejo"                               17.63   101.55

